// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rai_interfaces:srv/EmbodimentInfo.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rai_interfaces/srv/embodiment_info.h"


#ifndef RAI_INTERFACES__SRV__DETAIL__EMBODIMENT_INFO__STRUCT_H_
#define RAI_INTERFACES__SRV__DETAIL__EMBODIMENT_INFO__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in srv/EmbodimentInfo in the package rai_interfaces.
typedef struct rai_interfaces__srv__EmbodimentInfo_Request
{
  uint8_t structure_needs_at_least_one_member;
} rai_interfaces__srv__EmbodimentInfo_Request;

// Struct for a sequence of rai_interfaces__srv__EmbodimentInfo_Request.
typedef struct rai_interfaces__srv__EmbodimentInfo_Request__Sequence
{
  rai_interfaces__srv__EmbodimentInfo_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rai_interfaces__srv__EmbodimentInfo_Request__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'rules'
// Member 'capabilities'
// Member 'behaviors'
// Member 'description'
// Member 'images'
#include "rosidl_runtime_c/string.h"

/// Struct defined in srv/EmbodimentInfo in the package rai_interfaces.
typedef struct rai_interfaces__srv__EmbodimentInfo_Response
{
  rosidl_runtime_c__String__Sequence rules;
  rosidl_runtime_c__String__Sequence capabilities;
  rosidl_runtime_c__String__Sequence behaviors;
  rosidl_runtime_c__String description;
  /// base64 encoded png images
  rosidl_runtime_c__String__Sequence images;
} rai_interfaces__srv__EmbodimentInfo_Response;

// Struct for a sequence of rai_interfaces__srv__EmbodimentInfo_Response.
typedef struct rai_interfaces__srv__EmbodimentInfo_Response__Sequence
{
  rai_interfaces__srv__EmbodimentInfo_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rai_interfaces__srv__EmbodimentInfo_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  rai_interfaces__srv__EmbodimentInfo_Event__request__MAX_SIZE = 1
};
// response
enum
{
  rai_interfaces__srv__EmbodimentInfo_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/EmbodimentInfo in the package rai_interfaces.
typedef struct rai_interfaces__srv__EmbodimentInfo_Event
{
  service_msgs__msg__ServiceEventInfo info;
  rai_interfaces__srv__EmbodimentInfo_Request__Sequence request;
  rai_interfaces__srv__EmbodimentInfo_Response__Sequence response;
} rai_interfaces__srv__EmbodimentInfo_Event;

// Struct for a sequence of rai_interfaces__srv__EmbodimentInfo_Event.
typedef struct rai_interfaces__srv__EmbodimentInfo_Event__Sequence
{
  rai_interfaces__srv__EmbodimentInfo_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rai_interfaces__srv__EmbodimentInfo_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RAI_INTERFACES__SRV__DETAIL__EMBODIMENT_INFO__STRUCT_H_
