// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rai_interfaces:srv/EmbodimentInfo.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rai_interfaces/srv/embodiment_info.hpp"


#ifndef RAI_INTERFACES__SRV__DETAIL__EMBODIMENT_INFO__TRAITS_HPP_
#define RAI_INTERFACES__SRV__DETAIL__EMBODIMENT_INFO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rai_interfaces/srv/detail/embodiment_info__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace rai_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const EmbodimentInfo_Request & msg,
  std::ostream & out)
{
  (void)msg;
  out << "null";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const EmbodimentInfo_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const EmbodimentInfo_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::srv::EmbodimentInfo_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::srv::EmbodimentInfo_Request & msg)
{
  return rai_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::srv::EmbodimentInfo_Request>()
{
  return "rai_interfaces::srv::EmbodimentInfo_Request";
}

template<>
inline const char * name<rai_interfaces::srv::EmbodimentInfo_Request>()
{
  return "rai_interfaces/srv/EmbodimentInfo_Request";
}

template<>
struct has_fixed_size<rai_interfaces::srv::EmbodimentInfo_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<rai_interfaces::srv::EmbodimentInfo_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<rai_interfaces::srv::EmbodimentInfo_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rai_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const EmbodimentInfo_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: rules
  {
    if (msg.rules.size() == 0) {
      out << "rules: []";
    } else {
      out << "rules: [";
      size_t pending_items = msg.rules.size();
      for (auto item : msg.rules) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: capabilities
  {
    if (msg.capabilities.size() == 0) {
      out << "capabilities: []";
    } else {
      out << "capabilities: [";
      size_t pending_items = msg.capabilities.size();
      for (auto item : msg.capabilities) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: behaviors
  {
    if (msg.behaviors.size() == 0) {
      out << "behaviors: []";
    } else {
      out << "behaviors: [";
      size_t pending_items = msg.behaviors.size();
      for (auto item : msg.behaviors) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: description
  {
    out << "description: ";
    rosidl_generator_traits::value_to_yaml(msg.description, out);
    out << ", ";
  }

  // member: images
  {
    if (msg.images.size() == 0) {
      out << "images: []";
    } else {
      out << "images: [";
      size_t pending_items = msg.images.size();
      for (auto item : msg.images) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const EmbodimentInfo_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: rules
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.rules.size() == 0) {
      out << "rules: []\n";
    } else {
      out << "rules:\n";
      for (auto item : msg.rules) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: capabilities
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.capabilities.size() == 0) {
      out << "capabilities: []\n";
    } else {
      out << "capabilities:\n";
      for (auto item : msg.capabilities) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: behaviors
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.behaviors.size() == 0) {
      out << "behaviors: []\n";
    } else {
      out << "behaviors:\n";
      for (auto item : msg.behaviors) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: description
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "description: ";
    rosidl_generator_traits::value_to_yaml(msg.description, out);
    out << "\n";
  }

  // member: images
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.images.size() == 0) {
      out << "images: []\n";
    } else {
      out << "images:\n";
      for (auto item : msg.images) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const EmbodimentInfo_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::srv::EmbodimentInfo_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::srv::EmbodimentInfo_Response & msg)
{
  return rai_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::srv::EmbodimentInfo_Response>()
{
  return "rai_interfaces::srv::EmbodimentInfo_Response";
}

template<>
inline const char * name<rai_interfaces::srv::EmbodimentInfo_Response>()
{
  return "rai_interfaces/srv/EmbodimentInfo_Response";
}

template<>
struct has_fixed_size<rai_interfaces::srv::EmbodimentInfo_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rai_interfaces::srv::EmbodimentInfo_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rai_interfaces::srv::EmbodimentInfo_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace rai_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const EmbodimentInfo_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const EmbodimentInfo_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const EmbodimentInfo_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rai_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use rai_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rai_interfaces::srv::EmbodimentInfo_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  rai_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rai_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const rai_interfaces::srv::EmbodimentInfo_Event & msg)
{
  return rai_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rai_interfaces::srv::EmbodimentInfo_Event>()
{
  return "rai_interfaces::srv::EmbodimentInfo_Event";
}

template<>
inline const char * name<rai_interfaces::srv::EmbodimentInfo_Event>()
{
  return "rai_interfaces/srv/EmbodimentInfo_Event";
}

template<>
struct has_fixed_size<rai_interfaces::srv::EmbodimentInfo_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rai_interfaces::srv::EmbodimentInfo_Event>
  : std::integral_constant<bool, has_bounded_size<rai_interfaces::srv::EmbodimentInfo_Request>::value && has_bounded_size<rai_interfaces::srv::EmbodimentInfo_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<rai_interfaces::srv::EmbodimentInfo_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rai_interfaces::srv::EmbodimentInfo>()
{
  return "rai_interfaces::srv::EmbodimentInfo";
}

template<>
inline const char * name<rai_interfaces::srv::EmbodimentInfo>()
{
  return "rai_interfaces/srv/EmbodimentInfo";
}

template<>
struct has_fixed_size<rai_interfaces::srv::EmbodimentInfo>
  : std::integral_constant<
    bool,
    has_fixed_size<rai_interfaces::srv::EmbodimentInfo_Request>::value &&
    has_fixed_size<rai_interfaces::srv::EmbodimentInfo_Response>::value
  >
{
};

template<>
struct has_bounded_size<rai_interfaces::srv::EmbodimentInfo>
  : std::integral_constant<
    bool,
    has_bounded_size<rai_interfaces::srv::EmbodimentInfo_Request>::value &&
    has_bounded_size<rai_interfaces::srv::EmbodimentInfo_Response>::value
  >
{
};

template<>
struct is_service<rai_interfaces::srv::EmbodimentInfo>
  : std::true_type
{
};

template<>
struct is_service_request<rai_interfaces::srv::EmbodimentInfo_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rai_interfaces::srv::EmbodimentInfo_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // RAI_INTERFACES__SRV__DETAIL__EMBODIMENT_INFO__TRAITS_HPP_
