// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rai_interfaces:srv/EmbodimentInfo.idl
// generated code does not contain a copyright notice
#include "rai_interfaces/srv/detail/embodiment_info__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

bool
rai_interfaces__srv__EmbodimentInfo_Request__init(rai_interfaces__srv__EmbodimentInfo_Request * msg)
{
  if (!msg) {
    return false;
  }
  // structure_needs_at_least_one_member
  return true;
}

void
rai_interfaces__srv__EmbodimentInfo_Request__fini(rai_interfaces__srv__EmbodimentInfo_Request * msg)
{
  if (!msg) {
    return;
  }
  // structure_needs_at_least_one_member
}

bool
rai_interfaces__srv__EmbodimentInfo_Request__are_equal(const rai_interfaces__srv__EmbodimentInfo_Request * lhs, const rai_interfaces__srv__EmbodimentInfo_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // structure_needs_at_least_one_member
  if (lhs->structure_needs_at_least_one_member != rhs->structure_needs_at_least_one_member) {
    return false;
  }
  return true;
}

bool
rai_interfaces__srv__EmbodimentInfo_Request__copy(
  const rai_interfaces__srv__EmbodimentInfo_Request * input,
  rai_interfaces__srv__EmbodimentInfo_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // structure_needs_at_least_one_member
  output->structure_needs_at_least_one_member = input->structure_needs_at_least_one_member;
  return true;
}

rai_interfaces__srv__EmbodimentInfo_Request *
rai_interfaces__srv__EmbodimentInfo_Request__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__EmbodimentInfo_Request * msg = (rai_interfaces__srv__EmbodimentInfo_Request *)allocator.allocate(sizeof(rai_interfaces__srv__EmbodimentInfo_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rai_interfaces__srv__EmbodimentInfo_Request));
  bool success = rai_interfaces__srv__EmbodimentInfo_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rai_interfaces__srv__EmbodimentInfo_Request__destroy(rai_interfaces__srv__EmbodimentInfo_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rai_interfaces__srv__EmbodimentInfo_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rai_interfaces__srv__EmbodimentInfo_Request__Sequence__init(rai_interfaces__srv__EmbodimentInfo_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__EmbodimentInfo_Request * data = NULL;

  if (size) {
    data = (rai_interfaces__srv__EmbodimentInfo_Request *)allocator.zero_allocate(size, sizeof(rai_interfaces__srv__EmbodimentInfo_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rai_interfaces__srv__EmbodimentInfo_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rai_interfaces__srv__EmbodimentInfo_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rai_interfaces__srv__EmbodimentInfo_Request__Sequence__fini(rai_interfaces__srv__EmbodimentInfo_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rai_interfaces__srv__EmbodimentInfo_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rai_interfaces__srv__EmbodimentInfo_Request__Sequence *
rai_interfaces__srv__EmbodimentInfo_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__EmbodimentInfo_Request__Sequence * array = (rai_interfaces__srv__EmbodimentInfo_Request__Sequence *)allocator.allocate(sizeof(rai_interfaces__srv__EmbodimentInfo_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rai_interfaces__srv__EmbodimentInfo_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rai_interfaces__srv__EmbodimentInfo_Request__Sequence__destroy(rai_interfaces__srv__EmbodimentInfo_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rai_interfaces__srv__EmbodimentInfo_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rai_interfaces__srv__EmbodimentInfo_Request__Sequence__are_equal(const rai_interfaces__srv__EmbodimentInfo_Request__Sequence * lhs, const rai_interfaces__srv__EmbodimentInfo_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rai_interfaces__srv__EmbodimentInfo_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rai_interfaces__srv__EmbodimentInfo_Request__Sequence__copy(
  const rai_interfaces__srv__EmbodimentInfo_Request__Sequence * input,
  rai_interfaces__srv__EmbodimentInfo_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rai_interfaces__srv__EmbodimentInfo_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rai_interfaces__srv__EmbodimentInfo_Request * data =
      (rai_interfaces__srv__EmbodimentInfo_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rai_interfaces__srv__EmbodimentInfo_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rai_interfaces__srv__EmbodimentInfo_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rai_interfaces__srv__EmbodimentInfo_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `rules`
// Member `capabilities`
// Member `behaviors`
// Member `description`
// Member `images`
#include "rosidl_runtime_c/string_functions.h"

bool
rai_interfaces__srv__EmbodimentInfo_Response__init(rai_interfaces__srv__EmbodimentInfo_Response * msg)
{
  if (!msg) {
    return false;
  }
  // rules
  if (!rosidl_runtime_c__String__Sequence__init(&msg->rules, 0)) {
    rai_interfaces__srv__EmbodimentInfo_Response__fini(msg);
    return false;
  }
  // capabilities
  if (!rosidl_runtime_c__String__Sequence__init(&msg->capabilities, 0)) {
    rai_interfaces__srv__EmbodimentInfo_Response__fini(msg);
    return false;
  }
  // behaviors
  if (!rosidl_runtime_c__String__Sequence__init(&msg->behaviors, 0)) {
    rai_interfaces__srv__EmbodimentInfo_Response__fini(msg);
    return false;
  }
  // description
  if (!rosidl_runtime_c__String__init(&msg->description)) {
    rai_interfaces__srv__EmbodimentInfo_Response__fini(msg);
    return false;
  }
  // images
  if (!rosidl_runtime_c__String__Sequence__init(&msg->images, 0)) {
    rai_interfaces__srv__EmbodimentInfo_Response__fini(msg);
    return false;
  }
  return true;
}

void
rai_interfaces__srv__EmbodimentInfo_Response__fini(rai_interfaces__srv__EmbodimentInfo_Response * msg)
{
  if (!msg) {
    return;
  }
  // rules
  rosidl_runtime_c__String__Sequence__fini(&msg->rules);
  // capabilities
  rosidl_runtime_c__String__Sequence__fini(&msg->capabilities);
  // behaviors
  rosidl_runtime_c__String__Sequence__fini(&msg->behaviors);
  // description
  rosidl_runtime_c__String__fini(&msg->description);
  // images
  rosidl_runtime_c__String__Sequence__fini(&msg->images);
}

bool
rai_interfaces__srv__EmbodimentInfo_Response__are_equal(const rai_interfaces__srv__EmbodimentInfo_Response * lhs, const rai_interfaces__srv__EmbodimentInfo_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // rules
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->rules), &(rhs->rules)))
  {
    return false;
  }
  // capabilities
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->capabilities), &(rhs->capabilities)))
  {
    return false;
  }
  // behaviors
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->behaviors), &(rhs->behaviors)))
  {
    return false;
  }
  // description
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->description), &(rhs->description)))
  {
    return false;
  }
  // images
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->images), &(rhs->images)))
  {
    return false;
  }
  return true;
}

bool
rai_interfaces__srv__EmbodimentInfo_Response__copy(
  const rai_interfaces__srv__EmbodimentInfo_Response * input,
  rai_interfaces__srv__EmbodimentInfo_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // rules
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->rules), &(output->rules)))
  {
    return false;
  }
  // capabilities
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->capabilities), &(output->capabilities)))
  {
    return false;
  }
  // behaviors
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->behaviors), &(output->behaviors)))
  {
    return false;
  }
  // description
  if (!rosidl_runtime_c__String__copy(
      &(input->description), &(output->description)))
  {
    return false;
  }
  // images
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->images), &(output->images)))
  {
    return false;
  }
  return true;
}

rai_interfaces__srv__EmbodimentInfo_Response *
rai_interfaces__srv__EmbodimentInfo_Response__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__EmbodimentInfo_Response * msg = (rai_interfaces__srv__EmbodimentInfo_Response *)allocator.allocate(sizeof(rai_interfaces__srv__EmbodimentInfo_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rai_interfaces__srv__EmbodimentInfo_Response));
  bool success = rai_interfaces__srv__EmbodimentInfo_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rai_interfaces__srv__EmbodimentInfo_Response__destroy(rai_interfaces__srv__EmbodimentInfo_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rai_interfaces__srv__EmbodimentInfo_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rai_interfaces__srv__EmbodimentInfo_Response__Sequence__init(rai_interfaces__srv__EmbodimentInfo_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__EmbodimentInfo_Response * data = NULL;

  if (size) {
    data = (rai_interfaces__srv__EmbodimentInfo_Response *)allocator.zero_allocate(size, sizeof(rai_interfaces__srv__EmbodimentInfo_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rai_interfaces__srv__EmbodimentInfo_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rai_interfaces__srv__EmbodimentInfo_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rai_interfaces__srv__EmbodimentInfo_Response__Sequence__fini(rai_interfaces__srv__EmbodimentInfo_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rai_interfaces__srv__EmbodimentInfo_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rai_interfaces__srv__EmbodimentInfo_Response__Sequence *
rai_interfaces__srv__EmbodimentInfo_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__EmbodimentInfo_Response__Sequence * array = (rai_interfaces__srv__EmbodimentInfo_Response__Sequence *)allocator.allocate(sizeof(rai_interfaces__srv__EmbodimentInfo_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rai_interfaces__srv__EmbodimentInfo_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rai_interfaces__srv__EmbodimentInfo_Response__Sequence__destroy(rai_interfaces__srv__EmbodimentInfo_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rai_interfaces__srv__EmbodimentInfo_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rai_interfaces__srv__EmbodimentInfo_Response__Sequence__are_equal(const rai_interfaces__srv__EmbodimentInfo_Response__Sequence * lhs, const rai_interfaces__srv__EmbodimentInfo_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rai_interfaces__srv__EmbodimentInfo_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rai_interfaces__srv__EmbodimentInfo_Response__Sequence__copy(
  const rai_interfaces__srv__EmbodimentInfo_Response__Sequence * input,
  rai_interfaces__srv__EmbodimentInfo_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rai_interfaces__srv__EmbodimentInfo_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rai_interfaces__srv__EmbodimentInfo_Response * data =
      (rai_interfaces__srv__EmbodimentInfo_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rai_interfaces__srv__EmbodimentInfo_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rai_interfaces__srv__EmbodimentInfo_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rai_interfaces__srv__EmbodimentInfo_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `info`
#include "service_msgs/msg/detail/service_event_info__functions.h"
// Member `request`
// Member `response`
// already included above
// #include "rai_interfaces/srv/detail/embodiment_info__functions.h"

bool
rai_interfaces__srv__EmbodimentInfo_Event__init(rai_interfaces__srv__EmbodimentInfo_Event * msg)
{
  if (!msg) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__init(&msg->info)) {
    rai_interfaces__srv__EmbodimentInfo_Event__fini(msg);
    return false;
  }
  // request
  if (!rai_interfaces__srv__EmbodimentInfo_Request__Sequence__init(&msg->request, 0)) {
    rai_interfaces__srv__EmbodimentInfo_Event__fini(msg);
    return false;
  }
  // response
  if (!rai_interfaces__srv__EmbodimentInfo_Response__Sequence__init(&msg->response, 0)) {
    rai_interfaces__srv__EmbodimentInfo_Event__fini(msg);
    return false;
  }
  return true;
}

void
rai_interfaces__srv__EmbodimentInfo_Event__fini(rai_interfaces__srv__EmbodimentInfo_Event * msg)
{
  if (!msg) {
    return;
  }
  // info
  service_msgs__msg__ServiceEventInfo__fini(&msg->info);
  // request
  rai_interfaces__srv__EmbodimentInfo_Request__Sequence__fini(&msg->request);
  // response
  rai_interfaces__srv__EmbodimentInfo_Response__Sequence__fini(&msg->response);
}

bool
rai_interfaces__srv__EmbodimentInfo_Event__are_equal(const rai_interfaces__srv__EmbodimentInfo_Event * lhs, const rai_interfaces__srv__EmbodimentInfo_Event * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__are_equal(
      &(lhs->info), &(rhs->info)))
  {
    return false;
  }
  // request
  if (!rai_interfaces__srv__EmbodimentInfo_Request__Sequence__are_equal(
      &(lhs->request), &(rhs->request)))
  {
    return false;
  }
  // response
  if (!rai_interfaces__srv__EmbodimentInfo_Response__Sequence__are_equal(
      &(lhs->response), &(rhs->response)))
  {
    return false;
  }
  return true;
}

bool
rai_interfaces__srv__EmbodimentInfo_Event__copy(
  const rai_interfaces__srv__EmbodimentInfo_Event * input,
  rai_interfaces__srv__EmbodimentInfo_Event * output)
{
  if (!input || !output) {
    return false;
  }
  // info
  if (!service_msgs__msg__ServiceEventInfo__copy(
      &(input->info), &(output->info)))
  {
    return false;
  }
  // request
  if (!rai_interfaces__srv__EmbodimentInfo_Request__Sequence__copy(
      &(input->request), &(output->request)))
  {
    return false;
  }
  // response
  if (!rai_interfaces__srv__EmbodimentInfo_Response__Sequence__copy(
      &(input->response), &(output->response)))
  {
    return false;
  }
  return true;
}

rai_interfaces__srv__EmbodimentInfo_Event *
rai_interfaces__srv__EmbodimentInfo_Event__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__EmbodimentInfo_Event * msg = (rai_interfaces__srv__EmbodimentInfo_Event *)allocator.allocate(sizeof(rai_interfaces__srv__EmbodimentInfo_Event), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rai_interfaces__srv__EmbodimentInfo_Event));
  bool success = rai_interfaces__srv__EmbodimentInfo_Event__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rai_interfaces__srv__EmbodimentInfo_Event__destroy(rai_interfaces__srv__EmbodimentInfo_Event * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rai_interfaces__srv__EmbodimentInfo_Event__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rai_interfaces__srv__EmbodimentInfo_Event__Sequence__init(rai_interfaces__srv__EmbodimentInfo_Event__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__EmbodimentInfo_Event * data = NULL;

  if (size) {
    data = (rai_interfaces__srv__EmbodimentInfo_Event *)allocator.zero_allocate(size, sizeof(rai_interfaces__srv__EmbodimentInfo_Event), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rai_interfaces__srv__EmbodimentInfo_Event__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rai_interfaces__srv__EmbodimentInfo_Event__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rai_interfaces__srv__EmbodimentInfo_Event__Sequence__fini(rai_interfaces__srv__EmbodimentInfo_Event__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rai_interfaces__srv__EmbodimentInfo_Event__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rai_interfaces__srv__EmbodimentInfo_Event__Sequence *
rai_interfaces__srv__EmbodimentInfo_Event__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rai_interfaces__srv__EmbodimentInfo_Event__Sequence * array = (rai_interfaces__srv__EmbodimentInfo_Event__Sequence *)allocator.allocate(sizeof(rai_interfaces__srv__EmbodimentInfo_Event__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rai_interfaces__srv__EmbodimentInfo_Event__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rai_interfaces__srv__EmbodimentInfo_Event__Sequence__destroy(rai_interfaces__srv__EmbodimentInfo_Event__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rai_interfaces__srv__EmbodimentInfo_Event__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rai_interfaces__srv__EmbodimentInfo_Event__Sequence__are_equal(const rai_interfaces__srv__EmbodimentInfo_Event__Sequence * lhs, const rai_interfaces__srv__EmbodimentInfo_Event__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rai_interfaces__srv__EmbodimentInfo_Event__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rai_interfaces__srv__EmbodimentInfo_Event__Sequence__copy(
  const rai_interfaces__srv__EmbodimentInfo_Event__Sequence * input,
  rai_interfaces__srv__EmbodimentInfo_Event__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rai_interfaces__srv__EmbodimentInfo_Event);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rai_interfaces__srv__EmbodimentInfo_Event * data =
      (rai_interfaces__srv__EmbodimentInfo_Event *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rai_interfaces__srv__EmbodimentInfo_Event__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rai_interfaces__srv__EmbodimentInfo_Event__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rai_interfaces__srv__EmbodimentInfo_Event__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
