// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rai_interfaces:srv/ManipulatorMoveTo.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rai_interfaces/srv/manipulator_move_to.h"


#ifndef RAI_INTERFACES__SRV__DETAIL__MANIPULATOR_MOVE_TO__STRUCT_H_
#define RAI_INTERFACES__SRV__DETAIL__MANIPULATOR_MOVE_TO__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'target_pose'
#include "geometry_msgs/msg/detail/pose_stamped__struct.h"

/// Struct defined in srv/ManipulatorMoveTo in the package rai_interfaces.
typedef struct rai_interfaces__srv__ManipulatorMoveTo_Request
{
  /// A simplified approach with binary states for the gripper
  bool initial_gripper_state;
  bool final_gripper_state;
  geometry_msgs__msg__PoseStamped target_pose;
} rai_interfaces__srv__ManipulatorMoveTo_Request;

// Struct for a sequence of rai_interfaces__srv__ManipulatorMoveTo_Request.
typedef struct rai_interfaces__srv__ManipulatorMoveTo_Request__Sequence
{
  rai_interfaces__srv__ManipulatorMoveTo_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rai_interfaces__srv__ManipulatorMoveTo_Request__Sequence;

// Constants defined in the message

/// Struct defined in srv/ManipulatorMoveTo in the package rai_interfaces.
typedef struct rai_interfaces__srv__ManipulatorMoveTo_Response
{
  bool success;
} rai_interfaces__srv__ManipulatorMoveTo_Response;

// Struct for a sequence of rai_interfaces__srv__ManipulatorMoveTo_Response.
typedef struct rai_interfaces__srv__ManipulatorMoveTo_Response__Sequence
{
  rai_interfaces__srv__ManipulatorMoveTo_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rai_interfaces__srv__ManipulatorMoveTo_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  rai_interfaces__srv__ManipulatorMoveTo_Event__request__MAX_SIZE = 1
};
// response
enum
{
  rai_interfaces__srv__ManipulatorMoveTo_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/ManipulatorMoveTo in the package rai_interfaces.
typedef struct rai_interfaces__srv__ManipulatorMoveTo_Event
{
  service_msgs__msg__ServiceEventInfo info;
  rai_interfaces__srv__ManipulatorMoveTo_Request__Sequence request;
  rai_interfaces__srv__ManipulatorMoveTo_Response__Sequence response;
} rai_interfaces__srv__ManipulatorMoveTo_Event;

// Struct for a sequence of rai_interfaces__srv__ManipulatorMoveTo_Event.
typedef struct rai_interfaces__srv__ManipulatorMoveTo_Event__Sequence
{
  rai_interfaces__srv__ManipulatorMoveTo_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rai_interfaces__srv__ManipulatorMoveTo_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RAI_INTERFACES__SRV__DETAIL__MANIPULATOR_MOVE_TO__STRUCT_H_
