// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rai_interfaces:srv/VectorStoreRetrieval.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rai_interfaces/srv/vector_store_retrieval.h"


#ifndef RAI_INTERFACES__SRV__DETAIL__VECTOR_STORE_RETRIEVAL__STRUCT_H_
#define RAI_INTERFACES__SRV__DETAIL__VECTOR_STORE_RETRIEVAL__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'query'
#include "rosidl_runtime_c/string.h"

/// Struct defined in srv/VectorStoreRetrieval in the package rai_interfaces.
typedef struct rai_interfaces__srv__VectorStoreRetrieval_Request
{
  /// Request
  rosidl_runtime_c__String query;
} rai_interfaces__srv__VectorStoreRetrieval_Request;

// Struct for a sequence of rai_interfaces__srv__VectorStoreRetrieval_Request.
typedef struct rai_interfaces__srv__VectorStoreRetrieval_Request__Sequence
{
  rai_interfaces__srv__VectorStoreRetrieval_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rai_interfaces__srv__VectorStoreRetrieval_Request__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'message'
// Member 'documents'
// already included above
// #include "rosidl_runtime_c/string.h"
// Member 'scores'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in srv/VectorStoreRetrieval in the package rai_interfaces.
typedef struct rai_interfaces__srv__VectorStoreRetrieval_Response
{
  bool success;
  rosidl_runtime_c__String message;
  rosidl_runtime_c__String__Sequence documents;
  rosidl_runtime_c__float__Sequence scores;
} rai_interfaces__srv__VectorStoreRetrieval_Response;

// Struct for a sequence of rai_interfaces__srv__VectorStoreRetrieval_Response.
typedef struct rai_interfaces__srv__VectorStoreRetrieval_Response__Sequence
{
  rai_interfaces__srv__VectorStoreRetrieval_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rai_interfaces__srv__VectorStoreRetrieval_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  rai_interfaces__srv__VectorStoreRetrieval_Event__request__MAX_SIZE = 1
};
// response
enum
{
  rai_interfaces__srv__VectorStoreRetrieval_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/VectorStoreRetrieval in the package rai_interfaces.
typedef struct rai_interfaces__srv__VectorStoreRetrieval_Event
{
  service_msgs__msg__ServiceEventInfo info;
  rai_interfaces__srv__VectorStoreRetrieval_Request__Sequence request;
  rai_interfaces__srv__VectorStoreRetrieval_Response__Sequence response;
} rai_interfaces__srv__VectorStoreRetrieval_Event;

// Struct for a sequence of rai_interfaces__srv__VectorStoreRetrieval_Event.
typedef struct rai_interfaces__srv__VectorStoreRetrieval_Event__Sequence
{
  rai_interfaces__srv__VectorStoreRetrieval_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rai_interfaces__srv__VectorStoreRetrieval_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RAI_INTERFACES__SRV__DETAIL__VECTOR_STORE_RETRIEVAL__STRUCT_H_
