// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rai_interfaces:srv/WhatISee.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rai_interfaces/srv/what_i_see.hpp"


#ifndef RAI_INTERFACES__SRV__DETAIL__WHAT_I_SEE__STRUCT_HPP_
#define RAI_INTERFACES__SRV__DETAIL__WHAT_I_SEE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__rai_interfaces__srv__WhatISee_Request __attribute__((deprecated))
#else
# define DEPRECATED__rai_interfaces__srv__WhatISee_Request __declspec(deprecated)
#endif

namespace rai_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct WhatISee_Request_
{
  using Type = WhatISee_Request_<ContainerAllocator>;

  explicit WhatISee_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  explicit WhatISee_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  // field types and members
  using _structure_needs_at_least_one_member_type =
    uint8_t;
  _structure_needs_at_least_one_member_type structure_needs_at_least_one_member;


  // constant declarations

  // pointer types
  using RawPtr =
    rai_interfaces::srv::WhatISee_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rai_interfaces::srv::WhatISee_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rai_interfaces::srv::WhatISee_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rai_interfaces::srv::WhatISee_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::WhatISee_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::WhatISee_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::WhatISee_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::WhatISee_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rai_interfaces::srv::WhatISee_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rai_interfaces::srv::WhatISee_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rai_interfaces__srv__WhatISee_Request
    std::shared_ptr<rai_interfaces::srv::WhatISee_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rai_interfaces__srv__WhatISee_Request
    std::shared_ptr<rai_interfaces::srv::WhatISee_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const WhatISee_Request_ & other) const
  {
    if (this->structure_needs_at_least_one_member != other.structure_needs_at_least_one_member) {
      return false;
    }
    return true;
  }
  bool operator!=(const WhatISee_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct WhatISee_Request_

// alias to use template instance with default allocator
using WhatISee_Request =
  rai_interfaces::srv::WhatISee_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rai_interfaces


// Include directives for member types
// Member 'image'
#include "sensor_msgs/msg/detail/image__struct.hpp"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rai_interfaces__srv__WhatISee_Response __attribute__((deprecated))
#else
# define DEPRECATED__rai_interfaces__srv__WhatISee_Response __declspec(deprecated)
#endif

namespace rai_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct WhatISee_Response_
{
  using Type = WhatISee_Response_<ContainerAllocator>;

  explicit WhatISee_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : image(_init),
    pose(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->perception_source = "";
    }
  }

  explicit WhatISee_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : perception_source(_alloc),
    image(_alloc, _init),
    pose(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->perception_source = "";
    }
  }

  // field types and members
  using _observations_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>>;
  _observations_type observations;
  using _perception_source_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _perception_source_type perception_source;
  using _image_type =
    sensor_msgs::msg::Image_<ContainerAllocator>;
  _image_type image;
  using _pose_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _pose_type pose;

  // setters for named parameter idiom
  Type & set__observations(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>> & _arg)
  {
    this->observations = _arg;
    return *this;
  }
  Type & set__perception_source(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->perception_source = _arg;
    return *this;
  }
  Type & set__image(
    const sensor_msgs::msg::Image_<ContainerAllocator> & _arg)
  {
    this->image = _arg;
    return *this;
  }
  Type & set__pose(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->pose = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rai_interfaces::srv::WhatISee_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rai_interfaces::srv::WhatISee_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rai_interfaces::srv::WhatISee_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rai_interfaces::srv::WhatISee_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::WhatISee_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::WhatISee_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::WhatISee_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::WhatISee_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rai_interfaces::srv::WhatISee_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rai_interfaces::srv::WhatISee_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rai_interfaces__srv__WhatISee_Response
    std::shared_ptr<rai_interfaces::srv::WhatISee_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rai_interfaces__srv__WhatISee_Response
    std::shared_ptr<rai_interfaces::srv::WhatISee_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const WhatISee_Response_ & other) const
  {
    if (this->observations != other.observations) {
      return false;
    }
    if (this->perception_source != other.perception_source) {
      return false;
    }
    if (this->image != other.image) {
      return false;
    }
    if (this->pose != other.pose) {
      return false;
    }
    return true;
  }
  bool operator!=(const WhatISee_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct WhatISee_Response_

// alias to use template instance with default allocator
using WhatISee_Response =
  rai_interfaces::srv::WhatISee_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rai_interfaces


// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rai_interfaces__srv__WhatISee_Event __attribute__((deprecated))
#else
# define DEPRECATED__rai_interfaces__srv__WhatISee_Event __declspec(deprecated)
#endif

namespace rai_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct WhatISee_Event_
{
  using Type = WhatISee_Event_<ContainerAllocator>;

  explicit WhatISee_Event_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_init)
  {
    (void)_init;
  }

  explicit WhatISee_Event_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _info_type =
    service_msgs::msg::ServiceEventInfo_<ContainerAllocator>;
  _info_type info;
  using _request_type =
    rosidl_runtime_cpp::BoundedVector<rai_interfaces::srv::WhatISee_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rai_interfaces::srv::WhatISee_Request_<ContainerAllocator>>>;
  _request_type request;
  using _response_type =
    rosidl_runtime_cpp::BoundedVector<rai_interfaces::srv::WhatISee_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rai_interfaces::srv::WhatISee_Response_<ContainerAllocator>>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__info(
    const service_msgs::msg::ServiceEventInfo_<ContainerAllocator> & _arg)
  {
    this->info = _arg;
    return *this;
  }
  Type & set__request(
    const rosidl_runtime_cpp::BoundedVector<rai_interfaces::srv::WhatISee_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rai_interfaces::srv::WhatISee_Request_<ContainerAllocator>>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__response(
    const rosidl_runtime_cpp::BoundedVector<rai_interfaces::srv::WhatISee_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rai_interfaces::srv::WhatISee_Response_<ContainerAllocator>>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rai_interfaces::srv::WhatISee_Event_<ContainerAllocator> *;
  using ConstRawPtr =
    const rai_interfaces::srv::WhatISee_Event_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rai_interfaces::srv::WhatISee_Event_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rai_interfaces::srv::WhatISee_Event_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::WhatISee_Event_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::WhatISee_Event_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::WhatISee_Event_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::WhatISee_Event_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rai_interfaces::srv::WhatISee_Event_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rai_interfaces::srv::WhatISee_Event_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rai_interfaces__srv__WhatISee_Event
    std::shared_ptr<rai_interfaces::srv::WhatISee_Event_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rai_interfaces__srv__WhatISee_Event
    std::shared_ptr<rai_interfaces::srv::WhatISee_Event_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const WhatISee_Event_ & other) const
  {
    if (this->info != other.info) {
      return false;
    }
    if (this->request != other.request) {
      return false;
    }
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const WhatISee_Event_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct WhatISee_Event_

// alias to use template instance with default allocator
using WhatISee_Event =
  rai_interfaces::srv::WhatISee_Event_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rai_interfaces

namespace rai_interfaces
{

namespace srv
{

struct WhatISee
{
  using Request = rai_interfaces::srv::WhatISee_Request;
  using Response = rai_interfaces::srv::WhatISee_Response;
  using Event = rai_interfaces::srv::WhatISee_Event;
};

}  // namespace srv

}  // namespace rai_interfaces

#endif  // RAI_INTERFACES__SRV__DETAIL__WHAT_I_SEE__STRUCT_HPP_
